      SUBROUTINE MEMFIT_CLS(ND, NA, ITERNUM, KERN, D, SIGMA, M, 
     $     A, DA, ALPHA, DALPHA, EM)
      IMPLICIT NONE
      INCLUDE 'MEM_inc.f'
      INTEGER ND, NA, ITERNUM
      DOUBLE PRECISION KERN(ND, NA), D(ND), SIGMA(ND)
      DOUBLE PRECISION M(NA), A(NA), ALPHA, DA, DALPHA, EM(NA, NA)
      DOUBLE PRECISION KTK(NMAX, NMAX), KTD(NMAX), DDQ(NMAX, NMAX)
      DOUBLE PRECISION ALPHA0, ALPHA1, ALPHA2, CHI1
      DOUBLE PRECISION CHI, XCHI
      INTEGER I
      
      CALL SETUP_KTK(ND, NA, KERN, SIGMA, KTK)
      CALL SETUP_KTD(ND, NA, KERN, D, SIGMA, KTD)

      DO I = 1, NA
         A(I) = (1.0D0 + 1D-6) * M(I)
      END DO
      
      DA = 1.0D0
      DALPHA = 1.0D0
      ALPHA = 1.0D0
      I = 0
      DO WHILE((DA .GT. 1D-8 .OR. DALPHA. GT. 1D-8) 
     $     .AND. I .LE. ITERNUM)
         CALL SKILLING_ITR(NA, KTK, KTD, M, A, ALPHA, DA)
         CALL ALPHA_ITR(NA, KTK, M, A, ALPHA, DALPHA)
         I = I + 1
      END DO

      CALL ERROR_MATRIX(NA, KTK, A, ALPHA, DDQ, EM)

      RETURN

      END


      SUBROUTINE MEMFIT_FIXALPHA(ND, NA, ITERNUM, KERN, D, SIGMA, M, 
     $     A, DA, ALPHA, DALPHA, EM)
      IMPLICIT NONE
      INCLUDE 'MEM_inc.f'
      INTEGER ND, NA, ITERNUM
      DOUBLE PRECISION KERN(ND, NA), D(ND), SIGMA(ND)
      DOUBLE PRECISION M(NA), A(NA), ALPHA, DA, DALPHA, EM(NA, NA)
      DOUBLE PRECISION KTK(NMAX, NMAX), KTD(NMAX), DDQ(NMAX, NMAX)
      DOUBLE PRECISION ALPHA0, ALPHA1, ALPHA2, CHI1
      DOUBLE PRECISION CHI, XCHI
      INTEGER I
      
      CALL SETUP_KTK(ND, NA, KERN, SIGMA, KTK)
      CALL SETUP_KTD(ND, NA, KERN, D, SIGMA, KTD)

      DO I = 1, NA
         A(I) = (1.0D0 + 1D-6) * M(I)
      END DO
      
      DA = 1.0D0
      I = 0
      DO WHILE(DA .GT. 1D-8 .AND. I .LE. ITERNUM)
         CALL SKILLING_ITR(NA, KTK, KTD, M, A, ALPHA, DA)
         I = I + 1
      END DO

      CALL ERROR_MATRIX(NA, KTK, A, ALPHA, DDQ, EM)

      RETURN

      END



      SUBROUTINE MEMFIT_HST(ND, NA, ITERNUM, KERN, D, SIGMA, M, 
     $     A, DA, ALPHA, XCHI, EM)
      IMPLICIT NONE
      INCLUDE 'MEM_inc.f'
      INTEGER ND, NA, ITERNUM
      DOUBLE PRECISION KERN(ND, NA), D(ND), SIGMA(ND)
      DOUBLE PRECISION M(NA), A(NA), ALPHA, DA, EM(NA, NA)
      DOUBLE PRECISION KTK(NMAX, NMAX), KTD(NMAX), DDQ(NMAX, NMAX)
      DOUBLE PRECISION ALPHA0, ALPHA1, ALPHA2, CHI1
      DOUBLE PRECISION CHI, XCHI
      INTEGER I
      
      CALL SETUP_KTK(ND, NA, KERN, SIGMA, KTK)
      CALL SETUP_KTD(ND, NA, KERN, D, SIGMA, KTD)

      DO I = 1, NA
         A(I) = (1.0D0 + 1.0D-6) * M(I)
      END DO
      
      
      ALPHA0 = 0.0D0
      ALPHA2 = ALPHA
         
      ALPHA1 = ALPHA / 2.0D0
      CHI1 = DBLE(ND) * 2.0D0

      DO WHILE (ABS(CHI1-XCHI) .GE. 0.1D0)
         IF(ALPHA1 .LE. 1D-3)THEN
            WRITE(10, *) 'TARGET CHI^2 CAN NOT BE SATISFIED.'
            WRITE(*, *) 'TARGET CHI^2 CAN NOT BE SATISFIED.'
            STOP
         END IF
         IF(ALPHA - ALPHA1 .LE. 1D-3)THEN
            WRITE(10, *) 'TRY TO INCREASE PARAMETER ALPHA'
            WRITE(*, *) 'TRY TO INCREASE PARAMETER ALPHA'
            STOP
         END IF

         DA = 1.0D0
         I = 0
         DO WHILE(DA .GT. 1D-8 .AND. I .LE. ITERNUM)
            CALL SKILLING_ITR(NA, KTK, KTD, M, A, ALPHA1, DA)
            I = I + 1
         END DO
         CHI1 = CHI(ND, NA, KERN, D, SIGMA, A)
         IF(CHI1 .LE. XCHI)THEN
            ALPHA0 = ALPHA1
            ALPHA1 = (ALPHA1 + ALPHA2) / 2.0D0
         ELSE
            ALPHA2 = ALPHA1
            ALPHA1 = (ALPHA1 + ALPHA0) / 2.0D0
         END IF
C         PRINT*, ALPHA1, CHI1, DA
      END DO

      ALPHA = ALPHA1

      CALL ERROR_MATRIX(NA, KTK, A, ALPHA, DDQ, EM)

      RETURN

      END


      SUBROUTINE MEMFIT_BRYAN(ND, NA, ITERNUM, KERN, D, SIGMA, M, 
     $     A, DA, ALPHAMAX, DALPHA, EM)
      IMPLICIT NONE
      INCLUDE 'MEM_inc.f'
      INTEGER ND, NA, ITERNUM
      DOUBLE PRECISION KERN(ND, NA), D(ND), SIGMA(ND), A1(NMAX)
      DOUBLE PRECISION M(NA), A(NA), ALPHAMAX, DA, DALPHA, EM(NA, NA)
      DOUBLE PRECISION KTK(NMAX, NMAX), KTD(NMAX), DDQ(NMAX, NMAX),
     $     EM1(NMAX, NMAX)
      DOUBLE PRECISION ALPHA, PTOT
      DOUBLE PRECISION CHI, P_ALPHA, P
      INTEGER I, J

      OPEN(14, FILE='P.DAT')

      CALL SETUP_KTK(ND, NA, KERN, SIGMA, KTK)
      CALL SETUP_KTD(ND, NA, KERN, D, SIGMA, KTD)

      
      PTOT = 0.0D0

      DO I = 1, NA
         A(I) = 0.0D0
      END DO

      DO J = 1, NA
         DO I = 1, NA
            EM(I, J) = 0.0D0
         END DO
      END DO

      DO ALPHA = ALPHAMAX, DALPHA, -DALPHA
         DA = 1.0D0
         DO I = 1, NA
            A1(I) = (1.0D0 + 1D-6) * M(I)
         END DO

         I = 0
         DO WHILE(DA .GT. 1D-3 .AND. I .LE. ITERNUM)
            CALL SKILLING_ITR(NA, KTK, KTD, M, A1, ALPHA, DA)
            I = I + 1
         END DO

         P = P_ALPHA(ND, NA, KERN, D, SIGMA, KTK, M, A1, ALPHA)
         PTOT = P + PTOT

         DO I = 1, NA
            A(I) = A(I) + A1(I) * P
         END DO

         CALL ERROR_MATRIX(NA, KTK, A1, ALPHA, DDQ, EM1)
         CALL DAXPY(NA*NA, P, EM1, 1, EM, 1)

         WRITE(14, *) ALPHA, P
      END DO

      CALL DSCAL(NA, 1.0D0/PTOT, A, 1)
      CALL DSCAL(NA*NA, 1.0D0/PTOT, EM, 1)

      WRITE(10, *) 'LOG(W)             = ', LOG(PTOT * DALPHA)
      WRITE(* , *) 'LOG(W)             = ', LOG(PTOT * DALPHA)
      
      RETURN

      END



      SUBROUTINE SETUP_KTK(ND, NA, KERN, SIGMA, KTK)
      IMPLICIT NONE
      INCLUDE 'MEM_inc.f'
      INTEGER ND, NA
      DOUBLE PRECISION KERN(ND, NA), SIGMA(ND), KTK(NA, NA)
      INTEGER I, J, K

      DO J = 1, NA
         DO I = 1, NA
            KTK(I, J) = 0.0D0
            DO K = 1, ND
               KTK(I, J) = KTK(I, J) + KERN(K, I) * KERN(K, J) /
     $              SIGMA(K)**2
            END DO
         END DO
      END DO

      RETURN
      END



      SUBROUTINE SETUP_KTD(ND, NA, KERN, D, SIGMA, KTD)
      IMPLICIT NONE
      INCLUDE 'MEM_inc.f'
      INTEGER ND, NA
      DOUBLE PRECISION KERN(ND, NA), D(ND), SIGMA(ND)
      DOUBLE PRECISION KTD(NA)
      INTEGER I, J, K

      DO I = 1, NA
         KTD(I) = 0.0D0
         DO K = 1, ND
            KTD(I) = KTD(I) + KERN(K, I) * D(K) / SIGMA(K)**2
         END DO
      END DO

      RETURN
      END


      SUBROUTINE SKILLING_ITR(NA, KTK, KTD, M, A, ALPHA, DA)
      IMPLICIT NONE
      INCLUDE 'MEM_inc.f'
      INTEGER NA
      DOUBLE PRECISION KTK(NA, NA), KTD(NA), M(NA), A(NA), ALPHA, DA
      DOUBLE PRECISION E0(NMAX, 3), E(NMAX, 3), TEMP(NMAX)
      DOUBLE PRECISION Q(3, 3), V(3)
      DOUBLE PRECISION NRME1, NRME2, ETA, ETAMIN
      INTEGER I, J
      INTEGER IPIV(3), INFO
      DOUBLE PRECISION DNRM2, DDOT

C     ***
      DO I = 1, NA
         E0(I, 1) = - LOG(A(I) / M(I))
      END DO
      NRME1 = DNRM2(NA, E0(1, 1), 1)

C     ***
      CALL DCOPY(NA, KTD, 1, E0(1, 2), 1)
      CALL DGEMV('N', NA, NA, 1.0D0, KTK, NA, A, 1, -1.0D0, E0(1, 2), 1)
      NRME2 = DNRM2(NA, E0(1, 2), 1)


      DO I = 1, NA
         TEMP(I) = - E0(I, 2) + ALPHA * E0(I, 1)
      END DO
      DA =  DNRM2(NA, TEMP, 1)

C     ***
      DO I = 1, NA
         TEMP(I) = (E0(I, 1)/NRME1 - E0(I, 2)/NRME2) * A(I)
      END DO
      
      DO I = 1, NA
         E0(I, 3) = 0.0D0
      END DO
      CALL DGEMV('N', NA, NA, 1.0D0, KTK, NA, TEMP,1, 0.0D0, E0(1,3),1)

C     ***
      DO J = 1, 3
         DO I = 1, NA
            E(I, J) = A(I) * E0(I, J)
         END DO
      END DO

C     ***
      CALL DCOPY(NA, E0(1, 2), 1, TEMP, 1)
      CALL DAXPY(NA, -ALPHA, E0(1, 1), 1, TEMP, 1)

      DO J = 1, 3
         V(J) = -DDOT(NA, TEMP, 1, E(1, J), 1)
      END DO

C     ***
      DO J = 1, 3
         DO I = 1, NA
            TEMP(I) = E0(I, J) * ALPHA
         END DO

         CALL DGEMV('N', NA, NA, 1.0D0, KTK, NA, E(1, J), 1, 
     $        1.0D0, TEMP, 1)

         DO I = J, 3
            Q(I, J) = DDOT(NA, E(1, I), 1, TEMP, 1)
            Q(J, I) = Q(I, J)
         END DO
      END DO

      
      CALL DGESV(3, 1, Q, 3, IPIV, V, 3, INFO)

      DO I = 1, NA
         TEMP(I) = 0.0D0
      END DO
      DO I = 1, 3
         CALL DAXPY(NA, V(I), E(1, I), 1, TEMP, 1)
      END DO
      
C      DA = DNRM2(NA, TEMP, 1)

      ETAMIN = 1D0
      DO I = 1, NA
         IF(TEMP(i) .LT. 0.0D0)THEN
            ETA = - 0.5D0 * A(I) / TEMP(I)
            IF(ETA .LT. ETAMIN) ETAMIN = ETA
         END IF
      END DO

      CALL DAXPY(NA, ETAMIN, TEMP, 1, A, 1)
C      DA = DA * ETAMIN
 
      RETURN
      END

      


      SUBROUTINE ALPHA_ITR(NA, KTK, M, A, ALPHA, DALPHA)
      IMPLICIT NONE
      INCLUDE 'MEM_inc.f'
      INTEGER NA
      DOUBLE PRECISION KTK(NA, NA), M(NA), A(NA), ALPHA, DALPHA
      DOUBLE PRECISION AKTKA(NMAX, NMAX), LAMBDA(NMAX), S
      DOUBLE PRECISION ALPHA0, F, DF, DAL
      INTEGER LWORK, LIWORK, INFO
      PARAMETER(LWORK = 32 * NMAX, LIWORK = 10 * NMAX)
      DOUBLE PRECISION WORK(LWORK)
      INTEGER IWORK(LIWORK), ISUPPZ(2*NMAX)
      INTEGER I, J, L
      

      ALPHA0 = ALPHA

      DO J = 1, NA
         DO I = 1, NA
            AKTKA(I, J) = SQRT(A(I)) * KTK(I, J) * SQRT(A(J))
         END DO
      END DO

      CALL DSYEVR('N', 'A', 'U', NA, AKTKA, NMAX, 
     $     0.0D0, 0.0D0, 0, 0, 0.0D0, L, LAMBDA, AKTKA, NMAX, ISUPPZ,
     $     WORK, LWORK, IWORK, LIWORK, INFO )

      
      S = 0.0D0

      DO I = 1, NA
         S = S + A(I) - M(I) - A(I) * LOG(A(I) / M(I))
      END DO


      DAL = ALPHA
      DO WHILE (ABS(DAL) .GT. 1D-6 * ALPHA)
         F = 2.0D0 * ALPHA * S
         DF = 2.0D0 * S
         DO I = 1, NA
            F = F + LAMBDA(I) / (ALPHA + LAMBDA(I))
            DF = DF - LAMBDA(I) / (ALPHA + LAMBDA(I))**2
         END DO

         DAL = - F / DF * 0.1D0
        
         ALPHA = ALPHA + DAL
      END DO

      DALPHA = ABS(ALPHA - ALPHA0)

      RETURN
      END



      DOUBLE PRECISION FUNCTION P_ALPHA(ND, NA, KERN, D, SIGMA,
     $     KTK, M, A, ALPHA)
      IMPLICIT NONE
      INCLUDE 'MEM_inc.f'
      INTEGER ND, NA
      DOUBLE PRECISION KTK(NA, NA), M(NA), A(NA), ALPHA
      DOUBLE PRECISION KERN(ND, NA), SIGMA(ND), D(ND)
      DOUBLE PRECISION AKTKA(NMAX, NMAX), LAMBDA(NMAX), S
      INTEGER LWORK, LIWORK, INFO
      PARAMETER(LWORK = 32 * NMAX, LIWORK = 10 * NMAX)
      DOUBLE PRECISION WORK(LWORK)
      INTEGER IWORK(LIWORK), ISUPPZ(2*NMAX)
      DOUBLE PRECISION CHI, Q
      INTEGER I, J, L
      

      DO J = 1, NA
         DO I = 1, NA
            AKTKA(I, J) = SQRT(A(I)) * KTK(I, J) * SQRT(A(J))
         END DO
      END DO

      CALL DSYEVR('N', 'A', 'U', NA, AKTKA, NMAX, 
     $     0.0D0, 0.0D0, 0, 0, 0.0D0, L, LAMBDA, AKTKA, NMAX, ISUPPZ,
     $     WORK, LWORK, IWORK, LIWORK, INFO )

      
C     *** ENTROPY ***
      S = 0.0D0
      DO I = 1, NA
         S = S + A(I) - M(I) - A(I) * LOG(A(I) / M(I))
      END DO

      Q = ALPHA * S - CHI(ND, NA, KERN, D, SIGMA, A) / 2.0D0

      P_ALPHA = EXP(Q)
      DO I = 1, NA
         P_ALPHA = P_ALPHA * SQRT( ALPHA / (ALPHA + LAMBDA(I)))
      END DO
      P_ALPHA = P_ALPHA / ALPHA
      

      RETURN
      END
      

      DOUBLE PRECISION FUNCTION CHI(ND, NA, KERN, D, SIGMA, A)
      IMPLICIT NONE
      INCLUDE 'MEM_inc.f'
      INTEGER ND, NA
      DOUBLE PRECISION KERN(ND, NA), D(ND), SIGMA(ND), A(NA)
      INTEGER I
      DOUBLE PRECISION TEMP(NMAX)

      CALL DGEMV('N', ND, NA, 1.0D0, KERN, ND, A, 1, 0.0D0, TEMP, 1)
      CALL DAXPY(ND, -1.0D0, D, 1, TEMP, 1)

      CHI = 0.0D0
      DO I = 1, ND
         CHI = CHI + TEMP(I)**2 / SIGMA(I)**2
      END DO

      RETURN
      END



      SUBROUTINE ERROR_MATRIX(NA, KTK, A, ALPHA, DDQ, DADA)
      IMPLICIT NONE
      INCLUDE 'MEM_inc.f'
      INTEGER NA
      DOUBLE PRECISION KTK(NA, NA), DADA(NA, NA), DDQ(NA, NA)
      DOUBLE PRECISION A(NA), ALPHA, M(NA)
      INTEGER I, J,  IPIV(NMAX), INFO

      CALL DCOPY(NA*NA, KTK, 1, DDQ, 1)

      DO I = 1, NA
         DDQ(I, I) = DDQ(I, I) + ALPHA / A(I)
      END DO

      
      DO J = 1, NA
         DO I = 1, NA
            DADA(I, J) = 0.0D0
         END DO
      END DO

      DO I = 1, NA
         DADA(I, I) = 1.0D0
      END DO

      CALL DGESV(NA, NA, DDQ, NA, IPIV, DADA, NA, INFO)
 
      RETURN
      END




